;
;       Five silver dollars - machine plays against you moving five
;       silver dollars along a track - player unable to move loses
;

#define DatPtr(x)       ((x)+1)         ; useful SC/MP macros
#define High(x)         ((x)/256)
#define Low(x)          ((x) & 255)

Ram     .equ    0F00h
Kybd    .equ    0185h
Count   .equ    24h
Key     .equ    25h
Init    .equ    26h
E       .equ    80h

        .org    0F12h

Start:  .db     0FFh,3,5,8,9,0          ; starting position
Pos:                                    ; current position

        .org    0F28h

        ldi     High(Ram)
        xpah    2
        ldi     Low(Ram)
        xpal    2
        ldi     0Fh
        xpah    1
        ldi     Low(Pos)
        xpal    1
        ldi     6                       ; reset the game
        st      Count(2)
Setup:  ld      -6(1)
        st      @1(1)
        dld     Count(2)
        jnz     Setup
YMove:  ldi     0                       ; you go first
        st      Key(2)                  ; clear key store
;
;       generate display
;
Disp:   ldi     High(Pos)
        xpah    1
        ldi     Low(Pos)+1
        xpal    1
        ldi     9
Clear:  xae
        ldi     8
        st      E(2)
        lde
        cai     1
        jp      Clear
        ldi     5
        st      Count(2)
Npos:   ld      @1(1)
        rr
        jp      Even
Odd:    ani     07Fh
        xae
        ld      E(2)
        ori     30h                     ; segments E & F
        st      E(2)
        jmp     Cont
Even:   xae
        ld      E(2)
        ori     6                       ; segments B & C
        st      E(2)
Cont:   dld     Count(2)
        jnz     Npos
;
;       Display current position
;
Show:   ldi     High(Kybd)
        xpah    3
        ldi     Low(Kybd)-1
        xpal    3
        xppc    3
        jmp     Coma
        lde
        jz      Show
        scl
        cai     6
        jp      Show
        ldi     High(Pos)
        xpah    1
        ldi     Low(Pos)
        ccl
        ade
        xpal    1
        ld      (1)
        ccl
        adi     -1
        ccl
        cad     -1(1)
        jp      Fine2
        jmp     Show
Fine2:  ld      Key(2)
        jnz     Firstn
        lde
        st      Key(2)
Firstn: xre
        jnz     Disp-0F01h(2)
        dld     (1)
        jmp     Disp-0F01h(2)
Coma:
        ld      Key(2)
        jz      Disp-0F01h(2)
Go:     ldi     3
        st      Count(2)
        ldi     High(Pos)
        xpah    1
        ldi     Low(Pos)
        xpal    1
        ldi     0
        xae
Try:    ld      1(1)
        ccl
        cad     @2(1)
        st      4(1)
        xre
        xae
        dld     Count(2)
        jnz     Try
Solve:  lde
        jz      Nogo
        xor     (1)
        scl
        cad     @2(1)
        jp      Solve
        ccl
        add     -7(1)
        st      -7(1)
        jmp     YMove-0F01h(2)
Nogo:   ldi     5
        st      Count(2)
No:     ld      @-1(1)
        ccl
        adi     -1
        ccl
        cad     -1(1)
        jp      Fine
        dld     Count(2)
        jnz     No
        jmp     7(3)
Fine:   dld     (1)
        jmp     YMove-0F01h(2)

        .end

